
package org.dspace.administer;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.Iterator;
import java.sql.SQLException;
import java.io.OutputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStream;
import java.io.PrintStream;
import java.io.FileNotFoundException;
import java.io.IOException;

import org.apache.log4j.Logger;

import org.apache.commons.cli.CommandLine;
import org.apache.commons.cli.CommandLineParser;
import org.apache.commons.cli.HelpFormatter;
import org.apache.commons.cli.Option;
import org.apache.commons.cli.OptionGroup;
import org.apache.commons.cli.Options;
import org.apache.commons.cli.PosixParser;
import org.apache.commons.cli.MissingOptionException;

import org.dspace.core.PluginManager;
import org.dspace.core.ConfigurationManager;
import org.dspace.content.Bitstream;
import org.dspace.content.BitstreamFormat;
import org.dspace.content.format.DSpaceFormatRegistry;
import org.dspace.content.format.FormatRegistry;
import org.dspace.content.format.FormatHit;
import org.dspace.content.format.FormatIdentifier;
import org.dspace.content.format.FormatConfidence;
import org.dspace.content.format.FormatIdentifierManager;
import org.dspace.core.Context;
import org.dspace.storage.rdbms.DatabaseManager;
import org.dspace.storage.rdbms.TableRow;
import org.dspace.storage.rdbms.TableRowIterator;
import org.dspace.authorize.AuthorizeException;
import org.dspace.content.format.FormatRegistryException;
import org.dspace.content.format.FormatRegistryNotFoundException;
import org.dspace.content.format.FormatRegistryManager;
import org.dspace.content.format.ProvisionalFormatRegistry;
import org.dspace.content.format.DSpaceFormatRegistry;

/**
 * A command-line tool to ensure all Bitstreams are accessible.
 *
 * @author Larry Stone
 * @version $Revision: 1523 $
 */
public class CheckBitstreams
{


    public static void main(String[] argv)
        throws Exception
    {
        Context c = new Context();
        c.setIgnoreAuthorization(true);

        Iterator<Bitstream> bi = Bitstream.findAll(c);
        while (bi.hasNext())
        {
            Bitstream bs = bi.next();
            try
            {
                InputStream is = bs.retrieve();
                is.close();
            }
            catch (IOException e)
            {
                System.err.println("FAILED opening BitStream ID= "+bs.getID()+
                    ", name="+bs.getName());
            }
        }
    }
}
